#!/usr/bin/env node

const bin = require('.')
const co = require('co')
const path = require('path')
const fs = require('fs')

const install = (mods, argv) => co(function * () {
  for (let [name, version] of mods) yield bin(Object.assign(argv, { name, version }))
  return mods
})

const yargs = require('yargs') // eslint-disable-line
  .command('install', '安装全部依赖', ({ argv }) => {
    let file = path.join(process.cwd(), 'package.json')
    let pack = require(file)
    pack.binDependencies = pack.binDependencies || {}
    console.log('正在安装二进制依赖... 请稍等~')
    let mods = argv._.map(name => name.split('@')).filter(name => name.length === 2)
    if (mods.length) {
      install(mods, argv)
        .then(() => (pack.binDependencies = Object.assign(
          pack.binDependencies,
          mods.reduce((p, v) => (p[v[0]] = v[1]) && p, {})
        )) &&
          new Promise((resolve, reject) => fs.writeFile(file, JSON.stringify(pack, null, 2), err => err ? reject(err) : resolve())))
        .then(() => console.log(mods.length + ' 个模块已安装完成'))
        .catch(console.error)
    } else {
      install(Object.entries(pack.binDependencies), argv)
        .then(mods => console.log(mods.length + ' 个模块已安装完成'))
        .catch(console.error)
    }
  })
  .argv
